/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.applet.Applet;
import java.awt.*;
import java.io.*;

public class ChinaMine extends Applet
{
	private boolean  iconState=true;
	private Image akey;
	public static void exit()
	{
		Config.saveConfig();
		if(!Constant.isApplet)
//if it is an application, the progam will save the recodes when exit
		{
			System.exit(0);
		}
	}

	public static void main(String[] args)
	{
		int i=0;
//when you run this game as an application, the program start from here
		if(Incompatiable.incompatiable())
		{
			new Incompatiable(false);
			return;
		}
		Constant.isApplet=false;
		Constant.topApplet=new ChinaMine();

		try
		{
//get images for use
			Toolkit aKit=Toolkit.getDefaultToolkit();
			MediaTracker aTracker=new MediaTracker(Constant.topApplet);
			Image icon,block, face, led, akey;

			Constant.akeyIcon=akey=aKit.getImage("akey.gif");
			aTracker.addImage(akey,0);
			try
			{
				aTracker.waitForAll();
			}
			catch(InterruptedException e){};

			Constant.initLevelConst();
			Config.loadConfig();
			Constant.resetName();
			Constant.onlyFrame=new MainFrame();
		}
		catch(AWTError e){}
	}

	public void init()
	{
//when you start the game as an applet, it begin from here
		Constant.isApplet=true;
		Constant.topApplet=this;
		resize(Constant.iconButtonW,Constant.iconButtonH);
		MediaTracker aTracker=new MediaTracker(this);

//get images for use
		Constant.akeyIcon=akey=getImage(getCodeBase(),"akey.gif");
		aTracker.addImage(akey,0);

		try
		{
			aTracker.waitForAll();
		}
		catch(InterruptedException e){}

		Constant.initLevelConst();
		Config.loadConfig();
		Constant.styles[Config.style].getStyle();
		Constant.resetName();
	}

	public void paint(Graphics g)
	{
		if(Constant.isApplet)
			g.drawImage(iconState?Constant.styles[Config.style].iconup:Constant.styles[Config.style].icondown,0,0,this);
	}

	public boolean mouseDown(Event evt, int x, int y)
	{
		if( !MainFrame.isAlive() )
		{
			iconState=false;
			repaint();
			return true;
		}
		return false;
	}

	boolean firstInvoke=true;
	public boolean mouseUp(Event evt, int x, int y)
	{
		if(Incompatiable.incompatiable())
		{
			if(!Incompatiable.isAlive())
			{
				new Incompatiable(true);
				return true;
			}
			else
				return false;
		}
		else if( !MainFrame.isAlive() )
		{
			iconState=true;
			repaint();
			if(x>=0 && y>=0 && x<Constant.iconW && y<Constant.iconH)
			{
				Constant.onlyFrame=new MainFrame();
			}
			if(firstInvoke)
			{
				registPlay();
				firstInvoke=false;
			}
			return true;
		}
		else
			return false;
	}

	public String getAppletInfo()
	{
		return Constant.languages[0].copyright;
	}

	public String[][] getParameterInfo()
	{
		return Constant.parameterInfo;
	}

	void registPlay()
	{
		Thread counterThread=new Thread(new HitCounter());
		counterThread.start();
	}
}
