/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

public class LevelConst
{
	public int cols, rows, mines;
	public int faceX, timeX, panelW, panelH;
	public String levelNameLowerCased;
	public String levelNameFirstUpperCased;
	public String levelNameWithColonMark;
	public String winnerName;
	public int winnerScore;
	public String winnerNameWithoutTag;
	public int winnerScoreWithoutTag;

	public LevelConst(int cols, int rows, int mines)
	{
		panelW=24+cols*Constant.blockW;
		panelH=67+rows*Constant.blockH;
		faceX=(panelW-Constant.faceW)/2;
		timeX=panelW-58;
		this.cols=cols;
		this.rows=rows;
		this.mines=mines;
	}

	public void setName(String name)
	{
		levelNameLowerCased=name.toLowerCase();
		levelNameFirstUpperCased=name;
		levelNameWithColonMark=name+":";
	}

	public void resetWinner()
	{
		winnerName=Constant.languages[Config.language].anonymousName;
		winnerScore=Constant.anonymousTime;
		winnerNameWithoutTag=Constant.languages[Config.language].anonymousName;
		winnerScoreWithoutTag=Constant.anonymousTime;
	}
}